diff --git a/src/main/java/net/minecraft/core/util/collection/IntHashMap.java b/src/main/java/net/minecraft/core/util/collection/IntHashMap.java
new file mode 100644
index 000000000..f5c71c6de
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/collection/IntHashMap.java
@@ -0,0 +1,224 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package net.minecraft.core.util.collection;
+
+public class IntHashMap<V>
+{
+    private static final int DEFAULT_INITIAL_CAPACITY = 16;
+    private static final int MAXIMUM_CAPACITY = 1073741824;
+    private static final float DEFAULT_LOAD_FACTOR = 0.75f;
+    private transient Entry<V>[] table;
+    private transient int size;
+    private int threshold;
+    private final float loadFactor;
+    private transient volatile int modCount;
+    
+    public IntHashMap() {
+        this.loadFactor = DEFAULT_LOAD_FACTOR;
+        this.threshold = 12;
+        this.table = new Entry[DEFAULT_INITIAL_CAPACITY];
+    }
+    
+    private static int hash(int n) {
+        n ^= (n >>> 20 ^ n >>> 12);
+        return n ^ n >>> 7 ^ n >>> 4;
+    }
+    
+    private static int indexFor(final int n, final int n2) {
+        return n & n2 - 1;
+    }
+    
+    public int size() {
+        return this.size;
+    }
+    
+    public boolean isEmpty() {
+        return this.size == 0;
+    }
+    
+    public V get(final int n) {
+        for (Entry<V> next = this.table[indexFor(hash(n), this.table.length)]; next != null; next = next.next) {
+            if (next.key == n) {
+                return next.value;
+            }
+        }
+        return null;
+    }
+    
+    public boolean containsKey(final int n) {
+        return this.getEntry(n) != null;
+    }
+    
+    final Entry<V> getEntry(final int n) {
+        for (Entry<V> next = this.table[indexFor(hash(n), this.table.length)]; next != null; next = next.next) {
+            if (next.key == n) {
+                return next;
+            }
+        }
+        return null;
+    }
+    
+    public void put(final int n, final V value) {
+        final int hash = hash(n);
+        final int index = indexFor(hash, this.table.length);
+        for (Entry<V> next = this.table[index]; next != null; next = next.next) {
+            if (next.key == n) {
+                next.value = value;
+            }
+        }
+        ++this.modCount;
+        this.addEntry(hash, n, value, index);
+    }
+    
+    private void resize(final int n) {
+        if (this.table.length == MAXIMUM_CAPACITY) {
+            this.threshold = Integer.MAX_VALUE;
+            return;
+        }
+        final Entry[] table = new Entry[n];
+        this.transfer(table);
+        this.table = table;
+        this.threshold = (int)(n * this.loadFactor);
+    }
+    
+    private void transfer(final Entry<V>[] array) {
+        final Entry<V>[] table = this.table;
+        final int length = array.length;
+        for (int i = 0; i < table.length; ++i) {
+            Entry<V> entry = table[i];
+            if (entry != null) {
+                table[i] = null;
+                do {
+                    final Entry<V> next = entry.next;
+                    final int index = indexFor(entry.hash, length);
+                    entry.next = array[index];
+                    array[index] = entry;
+                    entry = next;
+                } while (entry != null);
+            }
+        }
+    }
+    
+    public V remove(final int n) {
+        final Entry<V> removeEntryForKey = this.removeEntryForKey(n);
+        return (removeEntryForKey == null) ? null : removeEntryForKey.value;
+    }
+    
+    final Entry<V> removeEntryForKey(final int n) {
+        final int index = indexFor(hash(n), this.table.length);
+        Entry<V> entry2;
+        Entry<V> next;
+        for (Entry<V> entry = entry2 = this.table[index]; entry2 != null; entry2 = next) {
+            next = entry2.next;
+            if (entry2.key == n) {
+                ++this.modCount;
+                --this.size;
+                if (entry == entry2) {
+                    this.table[index] = next;
+                }
+                else {
+                    entry.next = next;
+                }
+                return entry2;
+            }
+            entry = entry2;
+        }
+        return entry2;
+    }
+    
+    public void clear() {
+        ++this.modCount;
+        final Entry<V>[] table = this.table;
+        for (int i = 0; i < table.length; ++i) {
+            table[i] = null;
+        }
+        this.size = 0;
+    }
+    
+    public boolean containsValue(final Object o) {
+        if (o == null) {
+            return this.containsNullValue();
+        }
+        final Entry<V>[] table = this.table;
+        for (int i = 0; i < table.length; ++i) {
+            for (Entry<V> next = table[i]; next != null; next = next.next) {
+                if (o.equals(next.value)) {
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+    
+    private boolean containsNullValue() {
+        final Entry<V>[] table = this.table;
+        for (int i = 0; i < table.length; ++i) {
+            for (Entry<V> next = table[i]; next != null; next = next.next) {
+                if (next.value == null) {
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+    
+    private void addEntry(final int n, final int n2, final V v, final int n3) {
+        this.table[n3] = new Entry<V>(n, n2, v, this.table[n3]);
+        if (this.size++ >= this.threshold) {
+            this.resize(2 * this.table.length);
+        }
+    }
+    
+    private static class Entry<V>
+    {
+        final int key;
+        V value;
+        Entry<V> next;
+        final int hash;
+        
+        Entry(final int hash, final int key, final V value, final Entry<V> next) {
+            this.value = value;
+            this.next = next;
+            this.key = key;
+            this.hash = hash;
+        }
+        
+        public final int getKey() {
+            return this.key;
+        }
+        
+        public final V getValue() {
+            return this.value;
+        }
+        
+        @Override
+        public final boolean equals(final Object o) {
+            if (!(o instanceof Entry)) {
+                return false;
+            }
+            final Entry entry = (Entry)o;
+            final Integer value = this.getKey();
+            final Integer value2 = entry.getKey();
+            if (value == value2 || (value != null && value.equals(value2))) {
+                final Object value3 = this.getValue();
+                final Object value4 = entry.getValue();
+                if (value3 == value4 || (value3 != null && value3.equals(value4))) {
+                    return true;
+                }
+            }
+            return false;
+        }
+        
+        @Override
+        public final int hashCode() {
+            return hash(this.key);
+        }
+        
+        @Override
+        public final String toString() {
+            return this.getKey() + "=" + this.getValue();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/util/collection/LongHashMap.java b/src/main/java/net/minecraft/core/util/collection/LongHashMap.java
new file mode 100644
index 000000000..9a3672e12
--- /dev/null
+++ b/src/main/java/net/minecraft/core/util/collection/LongHashMap.java
@@ -0,0 +1,228 @@
+// 
+// Decompiled by Procyon v0.6.0
+// 
+
+package net.minecraft.core.util.collection;
+
+public class LongHashMap<V>
+{
+    private static final int DEFAULT_INITIAL_CAPACITY = 16;
+    private static final int MAXIMUM_CAPACITY = 1073741824;
+    private static final float DEFAULT_LOAD_FACTOR = 0.75f;
+    private transient Entry<V>[] table;
+    private transient int size;
+    private int threshold;
+    private final float loadFactor;
+    private transient volatile int modCount;
+    
+    public LongHashMap() {
+        this.loadFactor = DEFAULT_LOAD_FACTOR;
+        this.threshold = 12;
+        this.table = new Entry[DEFAULT_INITIAL_CAPACITY];
+    }
+    
+    private static int hash(final long n) {
+        return hash((int)(n ^ n >>> 32));
+    }
+    
+    private static int hash(int n) {
+        n ^= (n >>> 20 ^ n >>> 12);
+        return n ^ n >>> 7 ^ n >>> 4;
+    }
+    
+    private static int indexFor(final int n, final int n2) {
+        return n & n2 - 1;
+    }
+    
+    public int size() {
+        return this.size;
+    }
+    
+    public boolean isEmpty() {
+        return this.size == 0;
+    }
+    
+    public V get(final long n) {
+        for (Entry<V> next = this.table[indexFor(hash(n), this.table.length)]; next != null; next = next.next) {
+            if (next.key == n) {
+                return next.value;
+            }
+        }
+        return null;
+    }
+    
+    public boolean containsKey(final long n) {
+        return this.getEntry(n) != null;
+    }
+    
+    final Entry<V> getEntry(final long n) {
+        for (Entry<V> next = this.table[indexFor(hash(n), this.table.length)]; next != null; next = next.next) {
+            if (next.key == n) {
+                return next;
+            }
+        }
+        return null;
+    }
+    
+    public void put(final long n, final V value) {
+        final int hash = hash(n);
+        final int index = indexFor(hash, this.table.length);
+        for (Entry<V> next = this.table[index]; next != null; next = next.next) {
+            if (next.key == n) {
+                next.value = value;
+            }
+        }
+        ++this.modCount;
+        this.addEntry(hash, n, value, index);
+    }
+    
+    private void resize(final int n) {
+        if (this.table.length == MAXIMUM_CAPACITY) {
+            this.threshold = Integer.MAX_VALUE;
+            return;
+        }
+        final Entry[] table = new Entry[n];
+        this.transfer(table);
+        this.table = table;
+        this.threshold = (int)(n * this.loadFactor);
+    }
+    
+    private void transfer(final Entry<V>[] array) {
+        final Entry<V>[] table = this.table;
+        final int length = array.length;
+        for (int i = 0; i < table.length; ++i) {
+            Entry<V> entry = table[i];
+            if (entry != null) {
+                table[i] = null;
+                do {
+                    final Entry<V> next = entry.next;
+                    final int index = indexFor(entry.hash, length);
+                    entry.next = array[index];
+                    array[index] = entry;
+                    entry = next;
+                } while (entry != null);
+            }
+        }
+    }
+    
+    public V remove(final long n) {
+        final Entry<V> removeEntryForKey = this.removeEntryForKey(n);
+        return (removeEntryForKey == null) ? null : removeEntryForKey.value;
+    }
+    
+    final Entry<V> removeEntryForKey(final long n) {
+        final int index = indexFor(hash(n), this.table.length);
+        Entry<V> entry2;
+        Entry<V> next;
+        for (Entry<V> entry = entry2 = this.table[index]; entry2 != null; entry2 = next) {
+            next = entry2.next;
+            if (entry2.key == n) {
+                ++this.modCount;
+                --this.size;
+                if (entry == entry2) {
+                    this.table[index] = next;
+                }
+                else {
+                    entry.next = next;
+                }
+                return entry2;
+            }
+            entry = entry2;
+        }
+        return entry2;
+    }
+    
+    public void clear() {
+        ++this.modCount;
+        final Entry<V>[] table = this.table;
+        for (int i = 0; i < table.length; ++i) {
+            table[i] = null;
+        }
+        this.size = 0;
+    }
+    
+    public boolean containsValue(final Object o) {
+        if (o == null) {
+            return this.containsNullValue();
+        }
+        final Entry<V>[] table = this.table;
+        for (int i = 0; i < table.length; ++i) {
+            for (Entry<V> next = table[i]; next != null; next = next.next) {
+                if (o.equals(next.value)) {
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+    
+    private boolean containsNullValue() {
+        final Entry<V>[] table = this.table;
+        for (int i = 0; i < table.length; ++i) {
+            for (Entry<V> next = table[i]; next != null; next = next.next) {
+                if (next.value == null) {
+                    return true;
+                }
+            }
+        }
+        return false;
+    }
+    
+    private void addEntry(final int n, final long n2, final V v, final int n3) {
+        this.table[n3] = new Entry<V>(n, n2, v, this.table[n3]);
+        if (this.size++ >= this.threshold) {
+            this.resize(2 * this.table.length);
+        }
+    }
+    
+    private static class Entry<V>
+    {
+        final long key;
+        V value;
+        Entry<V> next;
+        final int hash;
+        
+        Entry(final int hash, final long key, final V value, final Entry<V> next) {
+            this.value = value;
+            this.next = next;
+            this.key = key;
+            this.hash = hash;
+        }
+        
+        public final long getKey() {
+            return this.key;
+        }
+        
+        public final V getValue() {
+            return this.value;
+        }
+        
+        @Override
+        public final boolean equals(final Object o) {
+            if (!(o instanceof Entry)) {
+                return false;
+            }
+            final Entry entry = (Entry)o;
+            final Long value = this.getKey();
+            final Long value2 = entry.getKey();
+            if (value == value2 || (value != null && value.equals(value2))) {
+                final Object value3 = this.getValue();
+                final Object value4 = entry.getValue();
+                if (value3 == value4 || (value3 != null && value3.equals(value4))) {
+                    return true;
+                }
+            }
+            return false;
+        }
+        
+        @Override
+        public final int hashCode() {
+            return hash(this.key);
+        }
+        
+        @Override
+        public final String toString() {
+            return this.getKey() + "=" + this.getValue();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/util/collection/NamespaceID.java b/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
index 18887264b..5bd5de90d 100644
--- a/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
+++ b/src/main/java/net/minecraft/core/util/collection/NamespaceID.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.util.collection;
 
+import net.minecraft.core.util.HardIllegalArgumentException;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Comparator;
@@ -7,16 +8,16 @@ import java.util.Comparator;
 public final class NamespaceID implements Comparator<NamespaceID>, Comparable<NamespaceID> {
     public final String namespace;
     public final String value;
-    public NamespaceID(String namespace, String value){
+    public NamespaceID(String namespace, String value) throws IllegalArgumentException {
         if (namespace.contains(":")) throw new IllegalArgumentException(namespace + " cannot contain the ':' character!");
         if (value.contains(":")) throw new IllegalArgumentException(value + " cannot contain the ':' character!");
         this.namespace = namespace;
         this.value = value;
     }
-    public NamespaceID(String formattedString){
-        if (!formattedString.contains(":")) throw new IllegalArgumentException("Formatted String '" + formattedString + "' missing ':' character all namespace ids must follow the format <namespace>:<value>!");
+    public NamespaceID(String formattedString) throws HardIllegalArgumentException {
+        if (!formattedString.contains(":")) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' missing ':' character all namespace ids must follow the format <namespace>:<value>!");
         String[] split = formattedString.split(":");
-        if (split.length != 2) throw new IllegalArgumentException("Formatted String '" + formattedString + "' has more then 1 ':' character! all namespace ids must follow the format <namespace>:<value>!");
+        if (split.length != 2) throw new HardIllegalArgumentException("Formatted String '" + formattedString + "' has more then 1 ':' character! all namespace ids must follow the format <namespace>:<value>!");
         namespace = split[0];
         value = split[1];
     }
diff --git a/src/main/java/net/minecraft/core/util/helper/Color.java b/src/main/java/net/minecraft/core/util/helper/Color.java
index 455486c9b..6329e1012 100644
--- a/src/main/java/net/minecraft/core/util/helper/Color.java
+++ b/src/main/java/net/minecraft/core/util/helper/Color.java
@@ -4,6 +4,11 @@ import com.b100.utils.InvalidCharacterException;
 import com.b100.utils.StringReader;
 
 public class Color {
+	public static final int SHIFT_ALPHA = 24;
+	public static final int SHIFT_RED = 16;
+	public static final int SHIFT_GREEN = 8;
+	public static final int SHIFT_BLUE = 0;
+	public static final int MASK_CHANNEL = 0xFF;
 
 	public int value;
 	
@@ -12,11 +17,11 @@ public class Color {
 	}
 	
 	public Color setRGBA(int r, int g, int b, int a) {
-		r = r & 0xFF;
-		g = g & 0xFF;
-		b = b & 0xFF;
-		a = a & 0xFF;
-		this.value = (a << 24) + (r << 16) + (g << 8) + b;
+		r = r & MASK_CHANNEL;
+		g = g & MASK_CHANNEL;
+		b = b & MASK_CHANNEL;
+		a = a & MASK_CHANNEL;
+		this.value = (a << SHIFT_ALPHA) + (r << SHIFT_RED) + (g << SHIFT_GREEN) + (b << SHIFT_BLUE);
 		return this;
 	}
 	
@@ -70,19 +75,19 @@ public class Color {
 	}
 	
 	public int getAlpha() {
-		return (value >> 24) & 0xFF;
+		return (value >> SHIFT_ALPHA) & MASK_CHANNEL;
 	}
 	
 	public int getRed() {
-		return (value >> 16) & 0xFF;
+		return (value >> SHIFT_RED) & MASK_CHANNEL;
 	}
 	
 	public int getGreen() {
-		return (value >> 8) & 0xFF;
+		return (value >> SHIFT_GREEN) & MASK_CHANNEL;
 	}
 	
 	public int getBlue() {
-		return value & 0xFF;
+		return (value >> SHIFT_BLUE) & MASK_CHANNEL;
 	}
 	
 	public String toPropertiesString() {
@@ -97,14 +102,7 @@ public class Color {
 	public String toString() {
 		return toHexRGBA();
 	}
-	
-	public static int byteToIntARGB(byte a, byte r, byte g, byte b) {
-		return ((a & 0xFF) << 24) + ((r & 0xFF) << 16) + ((g & 0xFF) << 8) + (b & 0xFF);
-	}
-	
-	public static int intToIntARGB(int a, int r, int g, int b) {
-		return ((a & 0xFF) << 24) + ((r & 0xFF) << 16) + ((g & 0xFF) << 8) + (b & 0xFF);
-	}
+
 
 	public void setRGB(Color newColor) {
 		setRGBA(newColor.getRed(), newColor.getGreen(), newColor.getBlue(), getAlpha());
@@ -113,5 +111,39 @@ public class Color {
 	public void setARGB(Color newColor) {
 		this.value = newColor.value;
 	}
-	
+
+
+	// Raw int handling methods
+
+	public static int byteToIntARGB(byte a, byte r, byte g, byte b) {
+		return ((a & MASK_CHANNEL) << SHIFT_ALPHA) + ((r & MASK_CHANNEL) << SHIFT_RED) + ((g & MASK_CHANNEL) << SHIFT_GREEN) + ((b & MASK_CHANNEL) << SHIFT_BLUE);
+	}
+	public static int shortToIntARGB(short a, short r, short g, short b) {
+		return ((a & MASK_CHANNEL) << SHIFT_ALPHA) + ((r & MASK_CHANNEL) << SHIFT_RED) + ((g & MASK_CHANNEL) << SHIFT_GREEN) + ((b & MASK_CHANNEL) << SHIFT_BLUE);
+	}
+	public static int intToIntARGB(int a, int r, int g, int b) {
+		return ((a & MASK_CHANNEL) << SHIFT_ALPHA) + ((r & MASK_CHANNEL) << SHIFT_RED) + ((g & MASK_CHANNEL) << SHIFT_GREEN) + ((b & MASK_CHANNEL) << SHIFT_BLUE);
+	}
+	public static int floatToIntARGB(float a, float r, float g, float b){
+		return intToIntARGB((int) (a * 255), (int) (r * 255), (int) (g * 255), (int) (b * 255));
+	}
+	public static int doubleToIntARGB(double a, double r, double g, double b){
+		return intToIntARGB((int) (a * 255), (int) (r * 255), (int) (g * 255), (int) (b * 255));
+	}
+
+	public static int alphaFromInt(int value) {
+		return (value >> SHIFT_ALPHA) & MASK_CHANNEL;
+	}
+
+	public static int redFromInt(int value) {
+		return (value >> SHIFT_RED) & MASK_CHANNEL;
+	}
+
+	public static int greenFromInt(int value) {
+		return (value >> SHIFT_GREEN) & MASK_CHANNEL;
+	}
+
+	public static int blueFromInt(int value) {
+		return (value >> SHIFT_BLUE) & MASK_CHANNEL;
+	}
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/DamageType.java b/src/main/java/net/minecraft/core/util/helper/DamageType.java
index 4a19b61c8..55d5b87a1 100644
--- a/src/main/java/net/minecraft/core/util/helper/DamageType.java
+++ b/src/main/java/net/minecraft/core/util/helper/DamageType.java
@@ -7,12 +7,12 @@ import java.util.List;
 public class DamageType {
 	private static final List<DamageType> values = new ArrayList<>();
 	
-    public static final DamageType COMBAT = new DamageType("damagetype.combat", true, true, 0);
-    public static final DamageType BLAST = new DamageType("damagetype.blast", true, true, 2);
-    public static final DamageType FALL = new DamageType("damagetype.fall", true, true, 3);
-    public static final DamageType FIRE = new DamageType("damagetype.fire", true, true, 4);
-	public static final DamageType DROWN = new DamageType("damagetype.drown", false, false, 0);
-	public static final DamageType GENERIC = new DamageType("damagetype.generic" ,true, false, 0);
+    public static final DamageType COMBAT = new DamageType("damagetype.combat", true, true, "minecraft:gui/hud/protection_combat");
+    public static final DamageType BLAST = new DamageType("damagetype.blast", true, true, "minecraft:gui/hud/protection_blast");
+    public static final DamageType FALL = new DamageType("damagetype.fall", true, true, "minecraft:gui/hud/protection_fall");
+    public static final DamageType FIRE = new DamageType("damagetype.fire", true, true, "minecraft:gui/hud/protection_fire");
+	public static final DamageType DROWN = new DamageType("damagetype.drown", false, false, "minecraft:gui/hud/protection_combat");
+	public static final DamageType GENERIC = new DamageType("damagetype.generic" ,true, false, "minecraft:gui/hud/protection_combat");
 
 	public static List<DamageType> values() {
 		return values;
@@ -21,15 +21,15 @@ public class DamageType {
 	private final String languageKey;
 	private final boolean shouldDamageArmor;
 	private final boolean shouldDisplay;
-	private final int iconIndex;
+	private final String iconIndex;
 	
-	public DamageType(String languageKey, boolean shouldDamageArmor, boolean shouldDisplay, int iconIndex) {
+	public DamageType(String languageKey, boolean shouldDamageArmor, boolean shouldDisplay, String icon) {
 		DamageType.values().add(this);
 
 		this.languageKey = languageKey;
 		this.shouldDamageArmor = shouldDamageArmor;
 		this.shouldDisplay = shouldDisplay;
-		this.iconIndex = iconIndex;
+		this.iconIndex = icon;
 	}
 
 	public String getLanguageKey() {
@@ -44,7 +44,7 @@ public class DamageType {
 		return shouldDisplay;
 	}
 	
-	public int getIconIndex() {
+	public String getIcon() {
 		return iconIndex;
 	}
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/Direction.java b/src/main/java/net/minecraft/core/util/helper/Direction.java
index 897d45303..39b2ca599 100644
--- a/src/main/java/net/minecraft/core/util/helper/Direction.java
+++ b/src/main/java/net/minecraft/core/util/helper/Direction.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.util.helper;
 
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 
 public enum Direction {
 	
@@ -150,21 +150,21 @@ public enum Direction {
 		else return DOWN;
 	}
 	
-	public static Direction getVerticalDirection(EntityLiving entity) {
+	public static Direction getVerticalDirection(Mob entity) {
 		if(entity.rotationLockVertical != null && entity.rotationLockVertical != NONE) return entity.rotationLockVertical;
 		else return getVerticalDirection(entity.xRot);
 	}
 	
 	public static Direction getHorizontalDirection(double rotationYaw) {
-		return horizontalDirections[(MathHelper.floor_double(rotationYaw / 90f + 0.5) + 2) & 3];
+		return horizontalDirections[(MathHelper.floor(rotationYaw / 90f + 0.5) + 2) & 3];
 	}
 	
-	public static Direction getHorizontalDirection(EntityLiving entity) {
+	public static Direction getHorizontalDirection(Mob entity) {
 		if(entity.rotationLockHorizontal != null && entity.rotationLockHorizontal != NONE) return entity.rotationLockHorizontal;
 		return getHorizontalDirection(entity.yRot);
 	}
 	
-	public static Direction getDirection(EntityLiving entity) {
+	public static Direction getDirection(Mob entity) {
 		if(entity.rotationLock != null && entity.rotationLock != NONE) return entity.rotationLock;
 		if(entity.xRot < -45) return UP;
 		if(entity.xRot > 45) return DOWN;
diff --git a/src/main/java/net/minecraft/core/util/helper/DyeColor.java b/src/main/java/net/minecraft/core/util/helper/DyeColor.java
index 50012d811..0be25b8ff 100644
--- a/src/main/java/net/minecraft/core/util/helper/DyeColor.java
+++ b/src/main/java/net/minecraft/core/util/helper/DyeColor.java
@@ -1,30 +1,72 @@
 package net.minecraft.core.util.helper;
 
-public enum DyeColor
-{
-	DYE_WHITE(0, 15),
-	DYE_ORANGE(1, 14),
-	DYE_MAGENTA(2, 13),
-	DYE_LIGHT_BLUE(3, 12),
-	DYE_YELLOW(4, 11),
-	DYE_LIME(5, 10),
-	DYE_PINK(6, 9),
-	DYE_GRAY(7, 8),
-	DYE_LIGHT_GRAY(8, 7),
-	DYE_CYAN(9, 6),
-	DYE_PURPLE(10, 5),
-	DYE_BLUE(11, 4),
-	DYE_BROWN(12, 3),
-	DYE_GREEN(13, 2),
-	DYE_RED(14, 1),
-	DYE_BLACK(15, 0);
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Unmodifiable;
 
-	public int blockMeta;
-	public int dyeMeta;
+import java.util.Arrays;
+import java.util.Collections;
+import java.util.List;
 
-	DyeColor(int blockMeta, int dyeMeta)
+public enum DyeColor
+{
+	WHITE(0, 15, "white", 0xf0f0f0),
+	ORANGE(1, 14, "orange", 0xeb8844),
+	MAGENTA(2, 13, "magenta", 0xc354cd),
+	LIGHT_BLUE(3, 12, "lightblue", 0x6689d3),
+	YELLOW(4, 11, "yellow", 0xdecf2a),
+	LIME(5, 10, "lime", 0x41cd34),
+	PINK(6, 9, "pink", 0xd88198),
+	GRAY(7, 8, "gray", 0x434343),
+	SILVER(8, 7, "silver", 0x9a9a9a),
+	CYAN(9, 6, "cyan", 0x287697),
+	PURPLE(10, 5, "purple", 0x7b2fbe),
+	BLUE(11, 4, "blue", 0x253192),
+	BROWN(12, 3, "brown", 0x51301a),
+	GREEN(13, 2, "green", 0x3b511a),
+	RED(14, 1, "red",0xb3312c),
+	BLACK(15, 0, "black", 0x1e1b1b);
+	public static final int COLOR_AMOUNT = 16;
+	public static final int MASK_COLOR = 0b0000_1111;
+	private static final DyeColor[] blockMetaToColor = new DyeColor[COLOR_AMOUNT];
+	private static final DyeColor[] itemMetaToColor = new DyeColor[COLOR_AMOUNT];
+	private static final List<DyeColor> blockMetaColorsList;
+	private static final List<DyeColor> itemMetaColorsList;
+	public final int blockMeta;
+	public final int itemMeta;
+	public final String colorID;
+	public final Color color;
+	DyeColor(int blockMeta, int itemMeta, String colorID, int color)
 	{
 		this.blockMeta = blockMeta;
-		this.dyeMeta = dyeMeta;
+		this.itemMeta = itemMeta;
+		this.colorID = colorID;
+		this.color = new Color().setARGB(color | 0xFF000000);
+	}
+
+	static {
+		for (DyeColor c : values()){
+			blockMetaToColor[c.blockMeta] = c;
+			itemMetaToColor[c.itemMeta] = c;
+		}
+		blockMetaColorsList = Collections.unmodifiableList(Arrays.asList(blockMetaToColor));
+		itemMetaColorsList = Collections.unmodifiableList(Arrays.asList(itemMetaToColor));
+
+	}
+	@NotNull
+	public static DyeColor colorFromBlockMeta(int blockMeta){
+		return blockMetaToColor[blockMeta & MASK_COLOR];
+	}
+	@NotNull
+	public static DyeColor colorFromItemMeta(int itemMeta){
+		return itemMetaToColor[itemMeta & MASK_COLOR];
+	}
+
+	@Unmodifiable
+	public static List<DyeColor> blockOrderedColors(){
+		return blockMetaColorsList;
+	}
+	@Unmodifiable
+	public static List<DyeColor> itemOrderedColors(){
+		return itemMetaColorsList;
 	}
 }
diff --git a/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java b/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
index b900beb62..65158d110 100644
--- a/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
+++ b/src/main/java/net/minecraft/core/util/helper/GetMonsterSkinUrlThread.java
@@ -4,7 +4,7 @@ import com.b100.json.JsonParser;
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.StringUtils;
-import net.minecraft.core.entity.monster.EntityHuman;
+import net.minecraft.core.entity.monster.HumanMob;
 
 import java.util.Base64;
 
@@ -17,10 +17,10 @@ public class GetMonsterSkinUrlThread extends Thread{
 
 	private static final JsonParser jsonParser = new JsonParser();
 
-	private EntityHuman monster;
+	private HumanMob monster;
 	private String uuid;
 
-	public GetMonsterSkinUrlThread(EntityHuman monster) {
+	public GetMonsterSkinUrlThread(HumanMob monster) {
 		this.monster = monster;
 		
 		setDaemon(true);
diff --git a/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java b/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java
index 4fa08312e..02dfb01af 100644
--- a/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java
+++ b/src/main/java/net/minecraft/core/util/helper/GetSkinUrlThread.java
@@ -6,7 +6,7 @@ import com.b100.json.JsonParser;
 import com.b100.json.element.JsonArray;
 import com.b100.json.element.JsonObject;
 import com.b100.utils.StringUtils;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 
 public class GetSkinUrlThread extends Thread{
 	
@@ -17,10 +17,10 @@ public class GetSkinUrlThread extends Thread{
 	
 	private static final JsonParser jsonParser = new JsonParser();
 	
-	private EntityPlayer player;
+	private Player player;
 	private String uuid;
 	
-	public GetSkinUrlThread(EntityPlayer player) {
+	public GetSkinUrlThread(Player player) {
 		this.player = player;
 		
 		setDaemon(true);
diff --git a/src/main/java/net/minecraft/core/util/helper/LogPrintStream.java b/src/main/java/net/minecraft/core/util/helper/LogPrintStream.java
index 5076ee602..3972438b9 100644
--- a/src/main/java/net/minecraft/core/util/helper/LogPrintStream.java
+++ b/src/main/java/net/minecraft/core/util/helper/LogPrintStream.java
@@ -109,7 +109,7 @@ public class LogPrintStream extends PrintStream{
 		boolean a = false;
 		for(int i=0; i < string.length(); i++) {
 			char c = string.charAt(i);
-			if(c == '\247') {
+			if(c == '§') {
 				a = true;
 			}else if(a) {
 				a = false;
